import os
import tkinter as tk
from tkinter.scrolledtext import ScrolledText
from tkinter import ttk
from defusedxml.ElementTree import parse

def storeNotes(event):
    notes = noteTextbox.get("1.0", "end-1c")
    with open("notes.txt", 'w') as notesFile:
        notesFile.write(notes)

def addRuneword():
    print(runewordListbox.get(runewordListbox.curselection()))
    print(itemBaseEntry.get())
    runesText = runewordListbox.get(runewordListbox.curselection())
    if itemBaseEntry.get() != "":
        noteList = runesText.split(": ")
        note = noteList[0] + " (" + itemBaseEntry.get() + "): " + noteList[1]
        print(note)
    else:
        note = runesText
    noteTextbox.insert('end', "\n" + note)
    storeNotes(None) # function normally takes event but we are calling manually
    runesText = runesText[runesText.find(": ")+2:]
    print("runesText: " + runesText)
    runesList = runesText.split("-")
    for rune in runesList:
        print(rune)
        if rune == "El":
            runesDesired[0] += 1
            updateRuneDesLabel(1)
        if rune == "Eld":
            runesDesired[1] += 1
            updateRuneDesLabel(2)
        if rune == "Tir":
            runesDesired[2] += 1
            updateRuneDesLabel(3)
        if rune == "Nef":
            runesDesired[3] += 1
            updateRuneDesLabel(4)
        if rune == "Eth":
            runesDesired[4] += 1
            updateRuneDesLabel(5)
        if rune == "Ith":
            runesDesired[5] += 1
            updateRuneDesLabel(6)
        if rune == "Tal":
            runesDesired[6] += 1
            updateRuneDesLabel(7)
        if rune == "Ral":
            runesDesired[7] += 1
            updateRuneDesLabel(8)
        if rune == "Ort":
            runesDesired[8] += 1
            updateRuneDesLabel(9)
        if rune == "Thul":
            runesDesired[9] += 1
            updateRuneDesLabel(10)
        if rune == "Amn":
            runesDesired[10] += 1
            updateRuneDesLabel(11)
        if rune == "Sol":
            runesDesired[11] += 1
            updateRuneDesLabel(12)
        if rune == "Shael":
            runesDesired[12] += 1
            updateRuneDesLabel(13)
        if rune == "Dol":
            runesDesired[13] += 1
            updateRuneDesLabel(14)
        if rune == "Hel":
            runesDesired[14] += 1
            updateRuneDesLabel(15)
        if rune == "Io":
            runesDesired[15] += 1
            updateRuneDesLabel(16)
        if rune == "Lum":
            runesDesired[16] += 1
            updateRuneDesLabel(17)
        if rune == "Ko":
            runesDesired[17] += 1
            updateRuneDesLabel(18)
        if rune == "Fal":
            runesDesired[18] += 1
            updateRuneDesLabel(19)
        if rune == "Lem":
            runesDesired[19] += 1
            updateRuneDesLabel(20)
        if rune == "Pul":
            runesDesired[20] += 1
            updateRuneDesLabel(21)
        if rune == "Um":
            runesDesired[21] += 1
            updateRuneDesLabel(22)
        if rune == "Mal":
            runesDesired[22] += 1
            updateRuneDesLabel(23)
        if rune == "Ist":
            runesDesired[23] += 1
            updateRuneDesLabel(24)
        if rune == "Gul":
            runesDesired[24] += 1
            updateRuneDesLabel(25)
        if rune == "Vex":
            runesDesired[25] += 1
            updateRuneDesLabel(26)
        if rune == "Ohm":
            runesDesired[26] += 1
            updateRuneDesLabel(27)
        if rune == "Lo":
            runesDesired[27] += 1
            updateRuneDesLabel(28)
        if rune == "Sur":
            runesDesired[28] += 1
            updateRuneDesLabel(29)
        if rune == "Ber":
            runesDesired[29] += 1
            updateRuneDesLabel(30)
        if rune == "Jah":
            runesDesired[30] += 1
            updateRuneDesLabel(31)
        if rune == "Cham":
            runesDesired[31] += 1
            updateRuneDesLabel(32)
        if rune == "Zod":
            runesDesired[32] += 1
            updateRuneDesLabel(33)

def loadRunewordXML():
    runewordList = []
    runewordStringVar = tk.StringVar()
    runewords = parse("runewords.xml").getroot()
    for runeword in runewords:
        if runeword.attrib["name"] != "":
#            print("name: " + runeword.attrib["name"])
            runewordString = runeword.attrib["name"] + ": "
            runes = runeword.find("runes")
            if runes != None:
                for rune in runes.findall("rune"):
#                    print("rune: " + rune.text)
                    runewordString += rune.text + "-"
                runewordString = runewordString[:-1]
#                print(runewordString)
                runewordList.append(runewordString)
    runewordStringVar = tk.StringVar(value = runewordList)
    return runewordStringVar

def breakDownRunes(rune):
    # only break down on USA Battle Net
    if upgradeStringVar.get() == "2":
#print("checking rune: " + str(rune))
        # dont break higher than Ber, we desire as many or more than we own or we own zero
        if (rune < 30) and (runesDesired[rune-1] > runesOwned[rune-1] or runesOwned[rune-1] == 0):
            # need to have more runes than needed to be able to break one down
            # if we dont have more than needed, check the next rune up
            if runesOwned[rune] <= runesDesired[rune]:
                breakDownRunes(rune+1)
            # we have enough of next higher rune to break down and still meet demand
            if runesOwned[rune] > runesDesired[rune]:
                runesOwned[rune] -= 1
                updateRuneQtyLabel(rune+1)
                runesOwned[rune-1] += 1
                runesOwned[rune-1] += 1
                updateRuneQtyLabel(rune)

def updateRuneQtyLabel(rune):
    if rune == 1:
        labelRune1Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune1El["background"] = "Green"
            else:
                labelRune1El["background"] = "Red"
        else:
            labelRune1El["background"] = ""
    elif rune == 2:
        labelRune2Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune2Eld["background"] = "Green"
            else:
                labelRune2Eld["background"] = "Red"
        else:
            labelRune2Eld["background"] = ""
    elif rune == 3:
        labelRune3Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune3Tir["background"] = "Green"
            else:
                labelRune3Tir["background"] = "Red"
        else:
            labelRune3Tir["background"] = ""
    elif rune == 4:
        labelRune4Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune4Nef["background"] = "Green"
            else:
                labelRune4Nef["background"] = "Red"
        else:
            labelRune4Nef["background"] = ""
    elif rune == 5:
        labelRune5Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune5Eth["background"] = "Green"
            else:
                labelRune5Eth["background"] = "Red"
        else:
            labelRune5Eth["background"] = ""
    elif rune == 6:
        labelRune6Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune6Ith["background"] = "Green"
            else:
                labelRune6Ith["background"] = "Red"
        else:
            labelRune6Ith["background"] = ""
    elif rune == 7:
        labelRune7Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune7Tal["background"] = "Green"
            else:
                labelRune7Tal["background"] = "Red"
        else:
            labelRune7Tal["background"] = ""
    elif rune == 8:
        labelRune8Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune8Ral["background"] = "Green"
            else:
                labelRune8Ral["background"] = "Red"
        else:
            labelRune8Ral["background"] = ""
    elif rune == 9:
        labelRune9Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune9Ort["background"] = "Green"
            else:
                labelRune9Ort["background"] = "Red"
        else:
            labelRune9Ort["background"] = ""
    elif rune == 10:
        labelRune10Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune10Thul["background"] = "Green"
            else:
                labelRune10Thul["background"] = "Red"
        else:
            labelRune10Thul["background"] = ""
    elif rune == 11:
        labelRune11Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune11Amn["background"] = "Green"
            else:
                labelRune11Amn["background"] = "Red"
        else:
            labelRune11Amn["background"] = ""
    elif rune == 12:
        labelRune12Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune12Sol["background"] = "Green"
            else:
                labelRune12Sol["background"] = "Red"
        else:
            labelRune12Sol["background"] = ""
    elif rune == 13:
        labelRune13Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune13Shael["background"] = "Green"
            else:
                labelRune13Shael["background"] = "Red"
        else:
            labelRune13Shael["background"] = ""
    elif rune == 14:
        labelRune14Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune14Dol["background"] = "Green"
            else:
                labelRune14Dol["background"] = "Red"
        else:
            labelRune14Dol["background"] = ""
    elif rune == 15:
        labelRune15Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune15Hel["background"] = "Green"
            else:
                labelRune15Hel["background"] = "Red"
        else:
            labelRune15Hel["background"] = ""
    elif rune == 16:
        labelRune16Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune16Io["background"] = "Green"
            else:
                labelRune16Io["background"] = "Red"
        else:
            labelRune16Io["background"] = ""
    elif rune == 17:
        labelRune17Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune17Lum["background"] = "Green"
            else:
                labelRune17Lum["background"] = "Red"
        else:
            labelRune17Lum["background"] = ""
    elif rune == 18:
        labelRune18Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune18Ko["background"] = "Green"
            else:
                labelRune18Ko["background"] = "Red"
        else:
            labelRune18Ko["background"] = ""
    elif rune == 19:
        labelRune19Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune19Fal["background"] = "Green"
            else:
                labelRune19Fal["background"] = "Red"
        else:
            labelRune19Fal["background"] = ""
    elif rune == 20:
        labelRune20Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune20Lem["background"] = "Green"
            else:
                labelRune20Lem["background"] = "Red"
        else:
            labelRune20Lem["background"] = ""
    elif rune == 21:
        labelRune21Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune21Pul["background"] = "Green"
            else:
                labelRune21Pul["background"] = "Red"
        else:
            labelRune21Pul["background"] = ""
    elif rune == 22:
        labelRune22Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune22Um["background"] = "Green"
            else:
                labelRune22Um["background"] = "Red"
        else:
            labelRune22Um["background"] = ""
    elif rune == 23:
        labelRune23Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune23Mal["background"] = "Green"
            else:
                labelRune23Mal["background"] = "Red"
        else:
            labelRune23Mal["background"] = ""
    elif rune == 24:
        labelRune24Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune24Ist["background"] = "Green"
            else:
                labelRune24Ist["background"] = "Red"
        else:
            labelRune24Ist["background"] = ""
    elif rune == 25:
        labelRune25Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune25Gul["background"] = "Green"
            else:
                labelRune25Gul["background"] = "Red"
        else:
            labelRune25Gul["background"] = ""
    elif rune == 26:
        labelRune26Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune26Vex["background"] = "Green"
            else:
                labelRune26Vex["background"] = "Red"
        else:
            labelRune26Vex["background"] = ""
    elif rune == 27:
        labelRune27Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune27Ohm["background"] = "Green"
            else:
                labelRune27Ohm["background"] = "Red"
        else:
            labelRune27Ohm["background"] = ""
    elif rune == 28:
        labelRune28Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune28Lo["background"] = "Green"
            else:
                labelRune28Lo["background"] = "Red"
        else:
            labelRune28Lo["background"] = ""
    elif rune == 29:
        labelRune29Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune29Sur["background"] = "Green"
            else:
                labelRune29Sur["background"] = "Red"
        else:
            labelRune29Sur["background"] = ""
    elif rune == 30:
        labelRune30Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune30Ber["background"] = "Green"
            else:
                labelRune30Ber["background"] = "Red"
        else:
            labelRune30Ber["background"] = ""
    elif rune == 31:
        labelRune31Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune31Jah["background"] = "Green"
            else:
                labelRune31Jah["background"] = "Red"
        else:
            labelRune31Jah["background"] = ""
    elif rune == 32:
        labelRune32Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune32Cham["background"] = "Green"
            else:
                labelRune32Cham["background"] = "Red"
        else:
            labelRune32Cham["background"] = ""
    elif rune == 33:
        labelRune33Qty["text"] = runesOwned[rune-1]
        if runesDesired[rune-1] > 0:
            if runesOwned[rune-1] >= runesDesired[rune-1]:
                labelRune33Zod["background"] = "Green"
            else:
                labelRune33Zod["background"] = "Red"
        else:
            labelRune33Zod["background"] = ""

def updateRuneDesLabel(rune):
    # calling updateQty updates label colors to reflect desired quantity changes
    updateRuneQtyLabel(rune)

    if rune == 1:
        labelRune1Des["text"] = runesDesired[rune-1]
    elif rune == 2:
        labelRune2Des["text"] = runesDesired[rune-1]
    elif rune == 3:
        labelRune3Des["text"] = runesDesired[rune-1]
    elif rune == 4:
        labelRune4Des["text"] = runesDesired[rune-1]
    elif rune == 5:
        labelRune5Des["text"] = runesDesired[rune-1]
    elif rune == 6:
        labelRune6Des["text"] = runesDesired[rune-1]
    elif rune == 7:
        labelRune7Des["text"] = runesDesired[rune-1]
    elif rune == 8:
        labelRune8Des["text"] = runesDesired[rune-1]
    elif rune == 9:
        labelRune9Des["text"] = runesDesired[rune-1]
    elif rune == 10:
        labelRune10Des["text"] = runesDesired[rune-1]
    elif rune == 11:
        labelRune11Des["text"] = runesDesired[rune-1]
    elif rune == 12:
        labelRune12Des["text"] = runesDesired[rune-1]
    elif rune == 13:
        labelRune13Des["text"] = runesDesired[rune-1]
    elif rune == 14:
        labelRune14Des["text"] = runesDesired[rune-1]
    elif rune == 15:
        labelRune15Des["text"] = runesDesired[rune-1]
    elif rune == 16:
        labelRune16Des["text"] = runesDesired[rune-1]
    elif rune == 17:
        labelRune17Des["text"] = runesDesired[rune-1]
    elif rune == 18:
        labelRune18Des["text"] = runesDesired[rune-1]
    elif rune == 19:
        labelRune19Des["text"] = runesDesired[rune-1]
    elif rune == 20:
        labelRune20Des["text"] = runesDesired[rune-1]
    elif rune == 21:
        labelRune21Des["text"] = runesDesired[rune-1]
    elif rune == 22:
        labelRune22Des["text"] = runesDesired[rune-1]
    elif rune == 23:
        labelRune23Des["text"] = runesDesired[rune-1]
    elif rune == 24:
        labelRune24Des["text"] = runesDesired[rune-1]
    elif rune == 25:
        labelRune25Des["text"] = runesDesired[rune-1]
    elif rune == 26:
        labelRune26Des["text"] = runesDesired[rune-1]
    elif rune == 27:
        labelRune27Des["text"] = runesDesired[rune-1]
    elif rune == 28:
        labelRune28Des["text"] = runesDesired[rune-1]
    elif rune == 29:
        labelRune29Des["text"] = runesDesired[rune-1]
    elif rune == 30:
        labelRune30Des["text"] = runesDesired[rune-1]
    elif rune == 31:
        labelRune31Des["text"] = runesDesired[rune-1]
    elif rune == 32:
        labelRune32Des["text"] = runesDesired[rune-1]
    elif rune == 33:
        labelRune33Des["text"] = runesDesired[rune-1]

def decreaseQtyButtonPressed(rune):
    if runesOwned[rune-1] > 0:
        runesOwned[rune-1] -= 1
    updateRuneQtyLabel(rune)

def increaseQtyButtonPressed(rune):
    runesOwned[rune-1] += 1
    if upgradeStringVar.get() == "2":
#    combine runes up to Ber on USA Battle Net
        if rune < 30 and runesOwned[rune-1] >= runesDesired[rune-1] + 2:
            runesOwned[rune-1] = runesOwned[rune-1] - 2
            increaseQtyButtonPressed(rune+1)
    updateRuneQtyLabel(rune)

def decreaseDesButtonPressed(rune):
    if runesDesired[rune-1] > 0:
        runesDesired[rune-1] -= 1
    updateRuneDesLabel(rune)

def increaseDesButtonPressed(rune):
    runesDesired[rune-1] += 1
    breakDownRunes(rune)
    updateRuneDesLabel(rune)

runesOwned = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
runesDesired = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

root = tk.Tk()
root.title("Starxplor's D2 Rune Tracker v0.9.0")
root.geometry("1200x800")
root.resizable(False, False)
#root.minsize(400,400)

lf = ttk.LabelFrame(root, text="Runes Owned")
lf.grid(row=1, column=1, rowspan=3)

labelRune1El = ttk.Label(lf, text="El: ")
labelRune1El.grid(row=1, column=1)
buttonDecreaseRune1 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(1))
buttonDecreaseRune1.grid(row=1, column=2, pady=3)
labelRune1Qty = ttk.Label(lf, text="0")
labelRune1Qty.grid(row=1, column=3, padx=5)
buttonIncreaseRune1 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(1))
buttonIncreaseRune1.grid(row=1, column=4)

labelRune2Eld = ttk.Label(lf, text="Eld: ")
labelRune2Eld.grid(row=2, column=1)
buttonDecreaseRune2 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(2))
buttonDecreaseRune2.grid(row=2, column=2, pady=3)
labelRune2Qty = ttk.Label(lf, text="0")
labelRune2Qty.grid(row=2, column=3, padx=5)
buttonIncreaseRune2 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(2))
buttonIncreaseRune2.grid(row=2, column=4)

labelRune3Tir = ttk.Label(lf, text="Tir: ")
labelRune3Tir.grid(row=3, column=1)
buttonDecreaseRune3 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(3))
buttonDecreaseRune3.grid(row=3, column=2, pady=3)
labelRune3Qty = ttk.Label(lf, text="0")
labelRune3Qty.grid(row=3, column=3, padx=5)
buttonIncreaseRune3 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(3))
buttonIncreaseRune3.grid(row=3, column=4)

labelRune4Nef = ttk.Label(lf, text="Nef: ")
labelRune4Nef.grid(row=4, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(4))
buttonDecreaseRune4.grid(row=4, column=2, pady=3)
labelRune4Qty = ttk.Label(lf, text="0")
labelRune4Qty.grid(row=4, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(4))
buttonIncreaseRune4.grid(row=4, column=4)

labelRune5Eth = ttk.Label(lf, text="Eth: ")
labelRune5Eth.grid(row=5, column=1)
buttonDecreaseRune5 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(5))
buttonDecreaseRune5.grid(row=5, column=2, pady=3)
labelRune5Qty = ttk.Label(lf, text="0")
labelRune5Qty.grid(row=5, column=3, padx=5)
buttonIncreaseRune5 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(5))
buttonIncreaseRune5.grid(row=5, column=4)

labelRune6Ith = ttk.Label(lf, text="Ith: ")
labelRune6Ith.grid(row=6, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(6))
buttonDecreaseRune4.grid(row=6, column=2, pady=3)
labelRune6Qty = ttk.Label(lf, text="0")
labelRune6Qty.grid(row=6, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(6))
buttonIncreaseRune4.grid(row=6, column=4)

labelRune7Tal = ttk.Label(lf, text="Tal: ")
labelRune7Tal.grid(row=7, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(7))
buttonDecreaseRune4.grid(row=7, column=2, pady=3)
labelRune7Qty = ttk.Label(lf, text="0")
labelRune7Qty.grid(row=7, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(7))
buttonIncreaseRune4.grid(row=7, column=4)

labelRune8Ral = ttk.Label(lf, text="Ral: ")
labelRune8Ral.grid(row=8, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(8))
buttonDecreaseRune4.grid(row=8, column=2, pady=3)
labelRune8Qty = ttk.Label(lf, text="0")
labelRune8Qty.grid(row=8, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(8))
buttonIncreaseRune4.grid(row=8, column=4)

labelRune9Ort = ttk.Label(lf, text="Ort: ")
labelRune9Ort.grid(row=9, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(9))
buttonDecreaseRune4.grid(row=9, column=2, pady=3)
labelRune9Qty = ttk.Label(lf, text="0")
labelRune9Qty.grid(row=9, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(9))
buttonIncreaseRune4.grid(row=9, column=4)

labelRune10Thul = ttk.Label(lf, text="Thul: ")
labelRune10Thul.grid(row=10, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(10))
buttonDecreaseRune4.grid(row=10, column=2, pady=3)
labelRune10Qty = ttk.Label(lf, text="0")
labelRune10Qty.grid(row=10, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(10))
buttonIncreaseRune4.grid(row=10, column=4)

labelRune11Amn = ttk.Label(lf, text="Amn: ")
labelRune11Amn.grid(row=11, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(11))
buttonDecreaseRune4.grid(row=11, column=2, pady=3)
labelRune11Qty = ttk.Label(lf, text="0")
labelRune11Qty.grid(row=11, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(11))
buttonIncreaseRune4.grid(row=11, column=4)

labelRune12Sol = ttk.Label(lf, text="Sol: ")
labelRune12Sol.grid(row=12, column=1)
buttonDecreaseRune12 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(12))
buttonDecreaseRune12.grid(row=12, column=2, pady=3)
labelRune12Qty = ttk.Label(lf, text="0")
labelRune12Qty.grid(row=12, column=3, padx=5)
buttonIncreaseRune12 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(12))
buttonIncreaseRune12.grid(row=12, column=4)

labelRune13Shael = ttk.Label(lf, text="Shael: ")
labelRune13Shael.grid(row=13, column=1)
buttonDecreaseRune13 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(13))
buttonDecreaseRune13.grid(row=13, column=2, pady=3)
labelRune13Qty = ttk.Label(lf, text="0")
labelRune13Qty.grid(row=13, column=3, padx=5)
buttonIncreaseRune13 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(13))
buttonIncreaseRune13.grid(row=13, column=4)

labelRune14Dol = ttk.Label(lf, text="Dol: ")
labelRune14Dol.grid(row=14, column=1)
buttonDecreaseRune4 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(14))
buttonDecreaseRune4.grid(row=14, column=2, pady=3)
labelRune14Qty = ttk.Label(lf, text="0")
labelRune14Qty.grid(row=14, column=3, padx=5)
buttonIncreaseRune4 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(14))
buttonIncreaseRune4.grid(row=14, column=4)

labelRune15Hel = ttk.Label(lf, text="Hel: ")
labelRune15Hel.grid(row=15, column=1)
buttonDecreaseRune15 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(15))
buttonDecreaseRune15.grid(row=15, column=2, pady=3)
labelRune15Qty = ttk.Label(lf, text="0")
labelRune15Qty.grid(row=15, column=3, padx=5)
buttonIncreaseRune15 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(15))
buttonIncreaseRune15.grid(row=15, column=4)

labelRune16Io = ttk.Label(lf, text="Io: ")
labelRune16Io.grid(row=16, column=1)
buttonDecreaseRune16 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(16))
buttonDecreaseRune16.grid(row=16, column=2, pady=3)
labelRune16Qty = ttk.Label(lf, text="0")
labelRune16Qty.grid(row=16, column=3, padx=5)
buttonIncreaseRune16 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(16))
buttonIncreaseRune16.grid(row=16, column=4)

labelRune17Lum = ttk.Label(lf, text="Lum: ")
labelRune17Lum.grid(row=17, column=1)
buttonDecreaseRune17 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(17))
buttonDecreaseRune17.grid(row=17, column=2, pady=3)
labelRune17Qty = ttk.Label(lf, text="0")
labelRune17Qty.grid(row=17, column=3, padx=5)
buttonIncreaseRune17 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(17))
buttonIncreaseRune17.grid(row=17, column=4)

labelRune18Ko = ttk.Label(lf, text="Ko: ")
labelRune18Ko.grid(row=18, column=1)
buttonDecreaseRune18 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(18))
buttonDecreaseRune18.grid(row=18, column=2, pady=3)
labelRune18Qty = ttk.Label(lf, text="0")
labelRune18Qty.grid(row=18, column=3, padx=5)
buttonIncreaseRune18 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(18))
buttonIncreaseRune18.grid(row=18, column=4)

labelRune19Fal = ttk.Label(lf, text="Fal: ")
labelRune19Fal.grid(row=19, column=1)
buttonDecreaseRune19 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(19))
buttonDecreaseRune19.grid(row=19, column=2, pady=3)
labelRune19Qty = ttk.Label(lf, text="0")
labelRune19Qty.grid(row=19, column=3, padx=5)
buttonIncreaseRune19 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(19))
buttonIncreaseRune19.grid(row=19, column=4)

labelRune20Lem = ttk.Label(lf, text="Lem: ")
labelRune20Lem.grid(row=20, column=1)
buttonDecreaseRune20 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(20))
buttonDecreaseRune20.grid(row=20, column=2, pady=3)
labelRune20Qty = ttk.Label(lf, text="0")
labelRune20Qty.grid(row=20, column=3, padx=5)
buttonIncreaseRune20 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(20))
buttonIncreaseRune20.grid(row=20, column=4)

labelRune21Pul = ttk.Label(lf, text="Pul: ")
labelRune21Pul.grid(row=21, column=1)
buttonDecreaseRune21 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(21))
buttonDecreaseRune21.grid(row=21, column=2, pady=3)
labelRune21Qty = ttk.Label(lf, text="0")
labelRune21Qty.grid(row=21, column=3, padx=5)
buttonIncreaseRune21 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(21))
buttonIncreaseRune21.grid(row=21, column=4)

labelRune22Um = ttk.Label(lf, text="Um: ")
labelRune22Um.grid(row=22, column=1)
buttonDecreaseRune22 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(22))
buttonDecreaseRune22.grid(row=22, column=2, pady=3)
labelRune22Qty = ttk.Label(lf, text="0")
labelRune22Qty.grid(row=22, column=3, padx=5)
buttonIncreaseRune22 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(22))
buttonIncreaseRune22.grid(row=22, column=4)

labelRune23Mal = ttk.Label(lf, text="Mal: ")
labelRune23Mal.grid(row=23, column=1)
buttonDecreaseRune23 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(23))
buttonDecreaseRune23.grid(row=23, column=2, pady=3)
labelRune23Qty = ttk.Label(lf, text="0")
labelRune23Qty.grid(row=23, column=3, padx=5)
buttonIncreaseRune23 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(23))
buttonIncreaseRune23.grid(row=23, column=4)

labelRune24Ist = ttk.Label(lf, text="Ist:")
labelRune24Ist.grid(row=1, column=6, padx=10)
buttonDecreaseRune24 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(24))
buttonDecreaseRune24.grid(row=1, column=7, pady=3)
labelRune24Qty = ttk.Label(lf, text="0")
labelRune24Qty.grid(row=1, column=8, padx=5)
buttonIncreaseRune24 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(24))
buttonIncreaseRune24.grid(row=1, column=9)

labelRune25Gul = ttk.Label(lf, text="Gul: ")
labelRune25Gul.grid(row=2, column=6, padx=10)
buttonDecreaseRune25 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(25))
buttonDecreaseRune25.grid(row=2, column=7, pady=3)
labelRune25Qty = ttk.Label(lf, text="0")
labelRune25Qty.grid(row=2, column=8, padx=5)
buttonIncreaseRune25 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(25))
buttonIncreaseRune25.grid(row=2, column=9)

labelRune26Vex = ttk.Label(lf, text="Vex: ")
labelRune26Vex.grid(row=3, column=6, padx=10)
buttonDecreaseRune26 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(26))
buttonDecreaseRune26.grid(row=3, column=7, pady=3)
labelRune26Qty = ttk.Label(lf, text="0")
labelRune26Qty.grid(row=3, column=8, padx=5)
buttonIncreaseRune26 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(26))
buttonIncreaseRune26.grid(row=3, column=9)

labelRune27Ohm = ttk.Label(lf, text="Ohm: ")
labelRune27Ohm.grid(row=4, column=6, padx=10)
buttonDecreaseRune27 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(27))
buttonDecreaseRune27.grid(row=4, column=7, pady=3)
labelRune27Qty = ttk.Label(lf, text="0")
labelRune27Qty.grid(row=4, column=8, padx=5)
buttonIncreaseRune27 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(27))
buttonIncreaseRune27.grid(row=4, column=9)

labelRune28Lo = ttk.Label(lf, text="Lo: ")
labelRune28Lo.grid(row=5, column=6, padx=10)
buttonDecreaseRune28 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(28))
buttonDecreaseRune28.grid(row=5, column=7, pady=3)
labelRune28Qty = ttk.Label(lf, text="0")
labelRune28Qty.grid(row=5, column=8, padx=5)
buttonIncreaseRune28 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(28))
buttonIncreaseRune28.grid(row=5, column=9)

labelRune29Sur = ttk.Label(lf, text="Sur: ")
labelRune29Sur.grid(row=6, column=6, padx=10)
buttonDecreaseRune29 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(29))
buttonDecreaseRune29.grid(row=6, column=7, pady=3)
labelRune29Qty = ttk.Label(lf, text="0")
labelRune29Qty.grid(row=6, column=8, padx=5)
buttonIncreaseRune29 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(29))
buttonIncreaseRune29.grid(row=6, column=9)

labelRune30Ber = ttk.Label(lf, text="Ber: ")
labelRune30Ber.grid(row=7, column=6, padx=10)
buttonDecreaseRune30 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(30))
buttonDecreaseRune30.grid(row=7, column=7, pady=3)
labelRune30Qty = ttk.Label(lf, text="0")
labelRune30Qty.grid(row=7, column=8, padx=5)
buttonIncreaseRune30 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(30))
buttonIncreaseRune30.grid(row=7, column=9)

labelRune31Jah = ttk.Label(lf, text="Jah: ")
labelRune31Jah.grid(row=8, column=6, padx=10)
buttonDecreaseRune31 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(31))
buttonDecreaseRune31.grid(row=8, column=7, pady=3)
labelRune31Qty = ttk.Label(lf, text="0")
labelRune31Qty.grid(row=8, column=8, padx=5)
buttonIncreaseRune31 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(31))
buttonIncreaseRune31.grid(row=8, column=9)

labelRune32Cham = ttk.Label(lf, text="Cham: ")
labelRune32Cham.grid(row=9, column=6, padx=10)
buttonDecreaseRune32 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(32))
buttonDecreaseRune32.grid(row=9, column=7, pady=3)
labelRune32Qty = ttk.Label(lf, text="0")
labelRune32Qty.grid(row=9, column=8, padx=5)
buttonIncreaseRune32 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(32))
buttonIncreaseRune32.grid(row=9, column=9)

labelRune33Zod = ttk.Label(lf, text="Zod: ")
labelRune33Zod.grid(row=10, column=6, padx=10)
buttonDecreaseRune33 = ttk.Button(lf, width=3, text="-", command=lambda: decreaseQtyButtonPressed(33))
buttonDecreaseRune33.grid(row=10, column=7, pady=3)
labelRune33Qty = ttk.Label(lf, text="0")
labelRune33Qty.grid(row=10, column=8, padx=5)
buttonIncreaseRune33 = ttk.Button(lf, width=3, text="+", command=lambda: increaseQtyButtonPressed(33))
buttonIncreaseRune33.grid(row=10, column=9)

lf2 = ttk.LabelFrame(root, text="Runes Desired")
#lf2.grid(row=1, column=2)
lf2.grid(row=1, column=2, rowspan=3, padx=10)

labelRuneDes1El = ttk.Label(lf2, text="El: ")
labelRuneDes1El.grid(row=1, column=1)
buttonDecreaseRuneDes1 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(1))
buttonDecreaseRuneDes1.grid(row=1, column=2, pady=3)
labelRune1Des = ttk.Label(lf2, text="0")
labelRune1Des.grid(row=1, column=3, padx=5)
buttonIncreaseRuneDes1 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(1))
buttonIncreaseRuneDes1.grid(row=1, column=4)

labelRuneDes2Eld = ttk.Label(lf2, text="Eld: ")
labelRuneDes2Eld.grid(row=2, column=1)
buttonDecreaseRuneDes2 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(2))
buttonDecreaseRuneDes2.grid(row=2, column=2, pady=3)
labelRune2Des = ttk.Label(lf2, text="0")
labelRune2Des.grid(row=2, column=3, padx=5)
buttonIncreaseRuneDes2 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(2))
buttonIncreaseRuneDes2.grid(row=2, column=4)

labelRuneDes3Tir = ttk.Label(lf2, text="Tir: ")
labelRuneDes3Tir.grid(row=3, column=1)
buttonDecreaseRuneDes3 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(3))
buttonDecreaseRuneDes3.grid(row=3, column=2, pady=3)
labelRune3Des = ttk.Label(lf2, text="0")
labelRune3Des.grid(row=3, column=3, padx=5)
buttonIncreaseRuneDes3 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(3))
buttonIncreaseRuneDes3.grid(row=3, column=4)

labelRuneDes4Nef = ttk.Label(lf2, text="Nef: ")
labelRuneDes4Nef.grid(row=4, column=1)
buttonDecreaseRuneDes4 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(4))
buttonDecreaseRuneDes4.grid(row=4, column=2, pady=3)
labelRune4Des = ttk.Label(lf2, text="0")
labelRune4Des.grid(row=4, column=3, padx=5)
buttonIncreaseRuneDes4 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(4))
buttonIncreaseRuneDes4.grid(row=4, column=4)

labelRuneDes5Eth = ttk.Label(lf2, text="Eth: ")
labelRuneDes5Eth.grid(row=5, column=1)
buttonDecreaseRuneDes5 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(5))
buttonDecreaseRuneDes5.grid(row=5, column=2, pady=3)
labelRune5Des = ttk.Label(lf2, text="0")
labelRune5Des.grid(row=5, column=3, padx=5)
buttonIncreaseRuneDes5 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(5))
buttonIncreaseRuneDes5.grid(row=5, column=4)

labelRuneDes6Ith = ttk.Label(lf2, text="Ith: ")
labelRuneDes6Ith.grid(row=6, column=1)
buttonDecreaseRuneDes6 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(6))
buttonDecreaseRuneDes6.grid(row=6, column=2, pady=3)
labelRune6Des = ttk.Label(lf2, text="0")
labelRune6Des.grid(row=6, column=3, padx=5)
buttonIncreaseRuneDes6 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(6))
buttonIncreaseRuneDes6.grid(row=6, column=4)

labelRuneDes7Tal = ttk.Label(lf2, text="Tal: ")
labelRuneDes7Tal.grid(row=7, column=1)
buttonDecreaseRuneDes7 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(7))
buttonDecreaseRuneDes7.grid(row=7, column=2, pady=3)
labelRune7Des = ttk.Label(lf2, text="0")
labelRune7Des.grid(row=7, column=3, padx=5)
buttonIncreaseRuneDes7 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(7))
buttonIncreaseRuneDes7.grid(row=7, column=4)

labelRuneDes8Ral = ttk.Label(lf2, text="Ral: ")
labelRuneDes8Ral.grid(row=8, column=1)
buttonDecreaseRuneDes8 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(8))
buttonDecreaseRuneDes8.grid(row=8, column=2, pady=3)
labelRune8Des = ttk.Label(lf2, text="0")
labelRune8Des.grid(row=8, column=3, padx=5)
buttonIncreaseRuneDes8 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(8))
buttonIncreaseRuneDes8.grid(row=8, column=4)

labelRuneDes9Ort = ttk.Label(lf2, text="Ort: ")
labelRuneDes9Ort.grid(row=9, column=1)
buttonDecreaseRuneDes9 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(9))
buttonDecreaseRuneDes9.grid(row=9, column=2, pady=3)
labelRune9Des = ttk.Label(lf2, text="0")
labelRune9Des.grid(row=9, column=3, padx=5)
buttonIncreaseRuneDes9 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(9))
buttonIncreaseRuneDes9.grid(row=9, column=4)

labelRuneDes10Thul = ttk.Label(lf2, text="Thul: ")
labelRuneDes10Thul.grid(row=10, column=1)
buttonDecreaseRuneDes10 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(10))
buttonDecreaseRuneDes10.grid(row=10, column=2, pady=3)
labelRune10Des = ttk.Label(lf2, text="0")
labelRune10Des.grid(row=10, column=3, padx=5)
buttonIncreaseRuneDes10 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(10))
buttonIncreaseRuneDes10.grid(row=10, column=4)

labelRuneDes11Amn = ttk.Label(lf2, text="Amn: ")
labelRuneDes11Amn.grid(row=11, column=1)
buttonDecreaseRuneDes11 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(11))
buttonDecreaseRuneDes11.grid(row=11, column=2, pady=3)
labelRune11Des = ttk.Label(lf2, text="0")
labelRune11Des.grid(row=11, column=3, padx=5)
buttonIncreaseRuneDes11 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(11))
buttonIncreaseRuneDes11.grid(row=11, column=4)

labelRuneDes12Sol = ttk.Label(lf2, text="Sol: ")
labelRuneDes12Sol.grid(row=12, column=1)
buttonDecreaseRuneDes12 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(12))
buttonDecreaseRuneDes12.grid(row=12, column=2, pady=3)
labelRune12Des = ttk.Label(lf2, text="0")
labelRune12Des.grid(row=12, column=3, padx=5)
buttonIncreaseRuneDes12 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(12))
buttonIncreaseRuneDes12.grid(row=12, column=4)

labelRuneDes13Shael = ttk.Label(lf2, text="Shael: ")
labelRuneDes13Shael.grid(row=13, column=1)
buttonDecreaseRuneDes13 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(13))
buttonDecreaseRuneDes13.grid(row=13, column=2, pady=3)
labelRune13Des = ttk.Label(lf2, text="0")
labelRune13Des.grid(row=13, column=3, padx=5)
buttonIncreaseRuneDes13 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(13))
buttonIncreaseRuneDes13.grid(row=13, column=4)

labelRuneDes14Dol = ttk.Label(lf2, text="Dol: ")
labelRuneDes14Dol.grid(row=14, column=1)
buttonDecreaseRuneDes14 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(14))
buttonDecreaseRuneDes14.grid(row=14, column=2, pady=3)
labelRune14Des = ttk.Label(lf2, text="0")
labelRune14Des.grid(row=14, column=3, padx=5)
buttonIncreaseRuneDes14 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(14))
buttonIncreaseRuneDes14.grid(row=14, column=4)

labelRuneDes15Hel = ttk.Label(lf2, text="Hel: ")
labelRuneDes15Hel.grid(row=15, column=1)
buttonDecreaseRuneDes15 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(15))
buttonDecreaseRuneDes15.grid(row=15, column=2, pady=3)
labelRune15Des = ttk.Label(lf2, text="0")
labelRune15Des.grid(row=15, column=3, padx=5)
buttonIncreaseRuneDes15 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(15))
buttonIncreaseRuneDes15.grid(row=15, column=4)

labelRuneDes16Io = ttk.Label(lf2, text="Io: ")
labelRuneDes16Io.grid(row=16, column=1)
buttonDecreaseRuneDes16 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(16))
buttonDecreaseRuneDes16.grid(row=16, column=2, pady=3)
labelRune16Des = ttk.Label(lf2, text="0")
labelRune16Des.grid(row=16, column=3, padx=5)
buttonIncreaseRuneDes16 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(16))
buttonIncreaseRuneDes16.grid(row=16, column=4)

labelRuneDes17Lum = ttk.Label(lf2, text="Lum: ")
labelRuneDes17Lum.grid(row=17, column=1)
buttonDecreaseRuneDes17 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(17))
buttonDecreaseRuneDes17.grid(row=17, column=2, pady=3)
labelRune17Des = ttk.Label(lf2, text="0")
labelRune17Des.grid(row=17, column=3, padx=5)
buttonIncreaseRuneDes17 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(17))
buttonIncreaseRuneDes17.grid(row=17, column=4)

labelRuneDes18Ko = ttk.Label(lf2, text="Ko: ")
labelRuneDes18Ko.grid(row=18, column=1)
buttonDecreaseRuneDes18 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(18))
buttonDecreaseRuneDes18.grid(row=18, column=2, pady=3)
labelRune18Des = ttk.Label(lf2, text="0")
labelRune18Des.grid(row=18, column=3, padx=5)
buttonIncreaseRuneDes18 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(18))
buttonIncreaseRuneDes18.grid(row=18, column=4)

labelRuneDes19Fal = ttk.Label(lf2, text="Fal: ")
labelRuneDes19Fal.grid(row=19, column=1)
buttonDecreaseRuneDes19 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(19))
buttonDecreaseRuneDes19.grid(row=19, column=2, pady=3)
labelRune19Des = ttk.Label(lf2, text="0")
labelRune19Des.grid(row=19, column=3, padx=5)
buttonIncreaseRuneDes19 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(19))
buttonIncreaseRuneDes19.grid(row=19, column=4)

labelRuneDes20Lem = ttk.Label(lf2, text="Lem: ")
labelRuneDes20Lem.grid(row=20, column=1)
buttonDecreaseRuneDes20 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(20))
buttonDecreaseRuneDes20.grid(row=20, column=2, pady=3)
labelRune20Des = ttk.Label(lf2, text="0")
labelRune20Des.grid(row=20, column=3, padx=5)
buttonIncreaseRuneDes20 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(20))
buttonIncreaseRuneDes20.grid(row=20, column=4)

labelRuneDes21Pul = ttk.Label(lf2, text="Pul: ")
labelRuneDes21Pul.grid(row=21, column=1)
buttonDecreaseRuneDes21 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(21))
buttonDecreaseRuneDes21.grid(row=21, column=2, pady=3)
labelRune21Des = ttk.Label(lf2, text="0")
labelRune21Des.grid(row=21, column=3, padx=5)
buttonIncreaseRuneDes21 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(21))
buttonIncreaseRuneDes21.grid(row=21, column=4)

labelRuneDes22Um = ttk.Label(lf2, text="Um: ")
labelRuneDes22Um.grid(row=22, column=1)
buttonDecreaseRuneDes22 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(22))
buttonDecreaseRuneDes22.grid(row=22, column=2, pady=3)
labelRune22Des = ttk.Label(lf2, text="0")
labelRune22Des.grid(row=22, column=3, padx=5)
buttonIncreaseRuneDes22 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(22))
buttonIncreaseRuneDes22.grid(row=22, column=4)

labelRuneDes23Mal = ttk.Label(lf2, text="Mal: ")
labelRuneDes23Mal.grid(row=23, column=1)
buttonDecreaseRuneDes23 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(23))
buttonDecreaseRuneDes23.grid(row=23, column=2, pady=3)
labelRune23Des = ttk.Label(lf2, text="0")
labelRune23Des.grid(row=23, column=3, padx=5)
buttonIncreaseRuneDes23 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(23))
buttonIncreaseRuneDes23.grid(row=23, column=4)

labelRuneDes24Ist = ttk.Label(lf2, text="Ist:")
labelRuneDes24Ist.grid(row=1, column=6, padx=10)
buttonDecreaseRuneDes24 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(24))
buttonDecreaseRuneDes24.grid(row=1, column=7, pady=3)
labelRune24Des = ttk.Label(lf2, text="0")
labelRune24Des.grid(row=1, column=8, padx=5)
buttonIncreaseRuneDes24 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(24))
buttonIncreaseRuneDes24.grid(row=1, column=9)

labelRuneDes25Gul = ttk.Label(lf2, text="Gul: ")
labelRuneDes25Gul.grid(row=2, column=6, padx=10)
buttonDecreaseRuneDes25 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(25))
buttonDecreaseRuneDes25.grid(row=2, column=7, pady=3)
labelRune25Des = ttk.Label(lf2, text="0")
labelRune25Des.grid(row=2, column=8, padx=5)
buttonIncreaseRuneDes25 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(25))
buttonIncreaseRuneDes25.grid(row=2, column=9)

labelRuneDes26Vex = ttk.Label(lf2, text="Vex: ")
labelRuneDes26Vex.grid(row=3, column=6, padx=10)
buttonDecreaseRuneDes26 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(26))
buttonDecreaseRuneDes26.grid(row=3, column=7, pady=3)
labelRune26Des = ttk.Label(lf2, text="0")
labelRune26Des.grid(row=3, column=8, padx=5)
buttonIncreaseRuneDes26 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(26))
buttonIncreaseRuneDes26.grid(row=3, column=9)

labelRuneDes27Ohm = ttk.Label(lf2, text="Ohm: ")
labelRuneDes27Ohm.grid(row=4, column=6, padx=10)
buttonDecreaseRuneDes27 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(27))
buttonDecreaseRuneDes27.grid(row=4, column=7, pady=3)
labelRune27Des = ttk.Label(lf2, text="0")
labelRune27Des.grid(row=4, column=8, padx=5)
buttonIncreaseRuneDes27 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(27))
buttonIncreaseRuneDes27.grid(row=4, column=9)

labelRuneDes28Lo = ttk.Label(lf2, text="Lo: ")
labelRuneDes28Lo.grid(row=5, column=6, padx=10)
buttonDecreaseRuneDes28 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(28))
buttonDecreaseRuneDes28.grid(row=5, column=7, pady=3)
labelRune28Des = ttk.Label(lf2, text="0")
labelRune28Des.grid(row=5, column=8, padx=5)
buttonIncreaseRuneDes28 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(28))
buttonIncreaseRuneDes28.grid(row=5, column=9)

labelRuneDes29Sur = ttk.Label(lf2, text="Sur: ")
labelRuneDes29Sur.grid(row=6, column=6, padx=10)
buttonDecreaseRuneDes29 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(29))
buttonDecreaseRuneDes29.grid(row=6, column=7, pady=3)
labelRune29Des = ttk.Label(lf2, text="0")
labelRune29Des.grid(row=6, column=8, padx=5)
buttonIncreaseRuneDes29 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(29))
buttonIncreaseRuneDes29.grid(row=6, column=9)

labelRuneDes30Ber = ttk.Label(lf2, text="Ber: ")
labelRuneDes30Ber.grid(row=7, column=6, padx=10)
buttonDecreaseRuneDes30 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(30))
buttonDecreaseRuneDes30.grid(row=7, column=7, pady=3)
labelRune30Des = ttk.Label(lf2, text="0")
labelRune30Des.grid(row=7, column=8, padx=5)
buttonIncreaseRuneDes30 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(30))
buttonIncreaseRuneDes30.grid(row=7, column=9)

labelRuneDes31Jah = ttk.Label(lf2, text="Jah: ")
labelRuneDes31Jah.grid(row=8, column=6, padx=10)
buttonDecreaseRuneDes31 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(31))
buttonDecreaseRuneDes31.grid(row=8, column=7, pady=3)
labelRune31Des = ttk.Label(lf2, text="0")
labelRune31Des.grid(row=8, column=8, padx=5)
buttonIncreaseRuneDes31 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(31))
buttonIncreaseRuneDes31.grid(row=8, column=9)

labelRuneDes32Cham = ttk.Label(lf2, text="Cham: ")
labelRuneDes32Cham.grid(row=9, column=6, padx=10)
buttonDecreaseRuneDes32 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(32))
buttonDecreaseRuneDes32.grid(row=9, column=7, pady=3)
labelRune32Des = ttk.Label(lf2, text="0")
labelRune32Des.grid(row=9, column=8, padx=5)
buttonIncreaseRuneDes32 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(32))
buttonIncreaseRuneDes32.grid(row=9, column=9)

labelRuneDes33Zod = ttk.Label(lf2, text="Zod: ")
labelRuneDes33Zod.grid(row=10, column=6, padx=10)
buttonDecreaseRuneDes33 = ttk.Button(lf2, width=3, text="-", command=lambda: decreaseDesButtonPressed(33))
buttonDecreaseRuneDes33.grid(row=10, column=7, pady=3)
labelRune33Des = ttk.Label(lf2, text="0")
labelRune33Des.grid(row=10, column=8, padx=5)
buttonIncreaseRuneDes33 = ttk.Button(lf2, width=3, text="+", command=lambda: increaseDesButtonPressed(33))
buttonIncreaseRuneDes33.grid(row=10, column=9)

upgradeFrame = ttk.Frame(root)
upgradeFrame.grid(row=1, column=3)
runeUpgradeLabel = ttk.Label(upgradeFrame, text="Number of runes needed to upgrade:")
runeUpgradeLabel.grid(row=1, column=1, columnspan=2, pady=(10,0))
upgradeStringVar = tk.StringVar(value="3")
runeUpgradeRadio = ttk.Radiobutton(upgradeFrame, text='2', value='2', variable=upgradeStringVar)
runeUpgradeRadio.grid(row=2, column=1)
runeUpgradeRadio = ttk.Radiobutton(upgradeFrame, text='3', value='3', variable=upgradeStringVar)
runeUpgradeRadio.grid(row=2, column=2)

lf3 = ttk.Frame(root)
lf3.grid(row=2, column=3)
runewordSelectLabel = ttk.Label(lf3, text="Select runeword to add to desired list:")
runewordSelectLabel.grid(row=3, column=1, columnspan=2, pady=(10,0))
runewordsStringVar = loadRunewordXML()
runewordListbox = tk.Listbox(lf3, listvariable=runewordsStringVar, selectbackground="Blue", selectmode="Single", height=5, width=40)
runewordListbox.grid(row=4, column=1, columnspan=2)
itemBaseSelectLabel = ttk.Label(lf3, text="Type optional base info for runeword: ")
itemBaseSelectLabel.grid(row=5, column=1, columnspan=2, pady=(10,0))
itemBaseEntry = ttk.Entry(lf3)
itemBaseEntry.grid(row=6, column=1, columnspan=2)
addRunewordButton = ttk.Button(lf3, text="Add runeword to list", command=addRuneword)
addRunewordButton.grid(row=7, column=1, columnspan=2, pady=(10,10))

noteTextbox = ScrolledText(root, width=65, height=25)
noteTextbox.bind('<KeyRelease>', storeNotes)
noteTextbox.grid(row=3, column=3)
#tree = ttk.Treeview(root)

# read from flat files, runes owned, runes desired, notes, runewords
print("reading state...")
try: # must load desired first so when loading owned list it updates color flag
    with open("runesDesired.txt", 'r') as runesDesiredFile:
        for i in range(33):
            runesDesired[i] = int(runesDesiredFile.readline())
            updateRuneDesLabel(i+1)
except FileNotFoundError:
    print("No saved desired quantity, ignoring...")

try:
    with open("runesOwned.txt", 'r') as runesOwnedFile:
        for i in range(33):
            runesOwned[i] = int(runesOwnedFile.readline())
            updateRuneQtyLabel(i+1)
except FileNotFoundError:
    print("No saved runes quantity, ignoring...")

try:
    with open("notes.txt", 'r') as notesFile:
        notes = notesFile.read()
        print("loading notes: " + notes)
        noteTextbox.insert('1.0', notes)
except FileNotFoundError:
    print("No saved notes, ignoring...")


root.mainloop()


# store in flat files, one for runes owned, one for runes desired, notes saved on change
print("saving state...")
with open("runesOwned.txt", 'w') as runesOwnedFile:
    for rune in runesOwned:
        runesOwnedFile.write(str(rune) + '\n')

with open("runesDesired.txt", 'w') as runesDesiredFile:
    for rune in runesDesired:
        runesDesiredFile.write(str(rune) + '\n')

